<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" integrity="sha384-JcKb8q3iqJ61gNV9KGb8thSsNjpSL0n8PARn9HuZOnIxN0hoP+VmmDGMN5t9UJ0Z" crossorigin="anonymous">

    <title>Hello, world!</title>
    <script src="https://cdn.jsdelivr.net/npm/vue/dist/vue.js"></script>
  </head>
  <body>
    <div id="app" class="container">
        <form>
            <div class="form-group">
                <input 
                    v-if="todo==null"
                    @keydown.enter.prevent="addTodo"
                    type="text" 
                    class="form-control" 
                    id="textTodo" 
                    placeholder="เพิ่มสิ่งที่ต้องทำ">

                <input 
                    v-else
                    @keydown.enter.prevent="editTodo"
                    type="text" 
                    class="form-control" 
                    id="textTodo" 
                    :value="todo.text"
                    placeholder="แก้ไขสิ่งที่ต้องทำ">
            </div>
          </form>
          <nav aria-label="Page navigation example">
            <ul class="pagination">
              <li class="page-item" v-if="pageNumber!=0">
                  <a class="page-link" href="#" @click="pageNumber--">Previous</a></li>
              <li class="page-item" v-for="page in getNumberOfPage">
                  <a class="page-link" href="#" @click="pageNumber=page-1">{{page}}</a></li>
              <li class="page-item" v-if="pageNumber!=getNumberOfPage-1"  @click="pageNumber--">
                  <a class="page-link" href="#">Next</a></li>
            </ul>
          </nav>
          <table class="table table-striped">
            <thead>
              <tr>
                <th scope="col">#</th>
                <th scope="col">Todo</th>
                <th scope="col">Operation 
                    <button type="button" 
                        v-if="todo!=null"
                        class="btn btn-success" @click="addNew">Add new</button></th>
              </tr>
            </thead>
            <tbody>
              <tr v-for="todo in getTodoByPaging">
                <th scope="row">{{todo.id}}</th>
                <td>{{todo.text}}</td>
                <td>
                    <button type="button" 
                        @click="editOperation(todo)"
                        class="btn btn-warning">edit</button>
                    <button type="button"
                        @click="delOperation(todo)"
                        class="btn btn-danger">delete</button>
                </td>
              </tr>
            </tbody>
          </table>
    </div>

    <script>
        var app = new Vue({
            el: '#app',
            data: {
                lastId: 5,
                todo: null,
                pageNumber: 0,
                pageSize: 3,
                todos:[
                    
                    {   id: 1,
                        text: 'ล้างจาน'
                    },
                    {   id: 2,
                        text: 'ซักผ้า'
                    },
                    {   id: 3,
                        text: 'ทำการบ้าน'
                    },
                    {   id: 4,
                        text: 'เล่นเกม'
                    },
                    
                ],
            },
            methods: {
                addTodo: function(event){
                    var newTodo ={ 
                        id: this.lastId++,
                        text: event.target.value
                    };
                    this.todos.push(newTodo);
                    event.target.value ="";
                },
                editTodo: function(event){
                    this.todo.text = event.target.value;
                    this.todo = null;
                },
                editOperation: function(todo){
                    this.todo = todo;
                    console.log(todo);
                },
                delOperation: function(todo){
                    var index = this.todos.findIndex(t => t.id == todo.id);
                    this.todos.splice(index, 1);
                },
                addNew: function(todo){
                    this.todo = null;
                }
                
            },
            computed: {
                getTodoByPaging: function(){
                    var begin = this.pageNumber*this.pageSize;
                    var end = begin+this.pageSize;
                    return this.todos.slice(begin,end);
                },
                getNumberOfPage: function(){
                    return Math.ceil(this.todos.length/this.pageSize);
                }
            },
        })
    </script>
    <script src="https://code.jquery.com/jquery-3.5.1.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.1/dist/umd/popper.min.js" integrity="sha384-9/reFTGAW83EW2RDu2S0VKaIzap3H66lZH81PoYlFhbGU+6BZp6G7niu735Sk7lN" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js" integrity="sha384-B4gt1jrGC7Jh4AgTPSdUtOBvfO8shuf57BaghqFfPlYxofvL8/KUEfYiJOMMV+rV" crossorigin="anonymous"></script>
  </body>
</html>